config/routes.rb
Rails.application.routes.draw do

  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  devise_for :users

  root 'static_pages#home'

  resources :line_items do
    match :qty, action: :qty, via: [:post, :delete], on: :member #-> url.com/line_items/qty
    match :input_field_change, action: :input_field_change, via: :post, on: :member
  end
  resources :carts do
    match :empty_line_items, action: :empty_line_items, via: :delete, on: :member #-> url.com/line_items/qty
  end

  get 'navbar_cart'           => 'carts#navbar_cart'
  get 'continue_shopping'     => 'carts#continue_shopping'
  get 'search'                => 'products#product_search'
  get 'checkout'              => 'charges#checkout'
  get 'support'               => 'support_messages#new'

  resources :carts, :orders
  resources :charges
  resources :categories, only: [:show, :index]
  resources :departments, only: [:index]
  resources :products, only: [:show, :index, :new, :create]
  resources :static_pages, only: [:home, :help]
  resources :support_messages, only: [:create]

   

end

app/models/admin_user.rb
class AdminUser < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, 
         :recoverable, :rememberable, :trackable, :validatable
end

app/models/attachment.rb
class Attachment < ActiveRecord::Base
	belongs_to :product
	mount_uploader :image, ImageUploader
end

app/models/cart.rb
class Cart < ActiveRecord::Base
	has_many :line_items, dependent: :destroy

	def add_product(product_id)
		current_item = line_items.find_by(product_id: product_id)
		if current_item
		else
			current_item = line_items.build(product_id: product_id)
		end
		current_item
	end

	def total_price
		line_items.to_a.sum { |item| item.total_price }
	end

	def decrease(line_item_id)
    current_item = line_items.find(line_item_id)
    if current_item.quantity > 1
      current_item.quantity -= 1
    else
      current_item.quantity = 1
    end
    current_item
  end

  def increase(line_item_id)
    current_item = line_items.find(line_item_id)
    if current_item.quantity >= 1
      current_item.quantity += 1
    else
      current_item.quantity = 1
    end
    current_item
  end

  def input_field_change(line_item_id, quantity)
  	current_item = line_items.find(line_item_id)
    if (current_item.quantity >= 1) and (quantity.to_f >= 1)
  	 current_item.quantity = quantity.to_f
    else
      current_item.quantity = 1
    end
  	current_item
  end
  
end

app/models/category.rb
class Category < ActiveRecord::Base
	mount_uploader :image, CategoryImageUploader
	belongs_to :department, counter_cache: true
	has_many :products


	
end

app/models/department.rb
class Department < ActiveRecord::Base
end

app/models/line_item.rb
class LineItem < ActiveRecord::Base

	belongs_to :order
	belongs_to :product
	belongs_to :cart, :counter_cache => true

 	def total_price
 		if !product.discount.blank?
  		(product.price - product.discount) * quantity
  	else
  		product.price * quantity
  	end
  end

  def check_qty
    self.destroy if self.qty.zero?
  end

end

app/models/order.rb
class Order < ActiveRecord::Base
	has_many :line_items, dependent: :destroy
	validates :name, :address, :email, presence: true
	belongs_to :user, :counter_cache => true
	STATUSES = ["Placed", "Changed", "Shipped", "Received"]
	PAYMENT_TYPES = [ "Card", "PayPal"]
	validates :status, inclusion: STATUSES, presence: true                     
	validates :pay_type, inclusion: PAYMENT_TYPES, presence: true  

	def add_line_items_from_cart(cart)
		cart.line_items.each do |item|
			item.cart_id = nil
			line_items << item
		end
	end

	def total_price
		line_items.to_a.sum { |item| item.total_price }
	end
end

app/models/product.rb
class Product < ActiveRecord::Base
	belongs_to :category, dependent: :destroy, counter_cache: true
	has_one :department, through: :category
	has_many :line_items
	has_many :orders, through: :line_items
	has_many :attachments, dependent: :destroy
	has_many :product_attributes
	accepts_nested_attributes_for :attachments, allow_destroy: true
	accepts_nested_attributes_for :product_attributes, allow_destroy: true
	before_destroy :ensure_not_referenced_by_any_line_item

	def self.search(search, selected)
		if selected.present?
	  	where("category_id = :selected AND title ILIKE :search", selected: selected, search: "%#{search}%" )
		else
			where("title ILIKE :search", search: "%#{search}%" )
		end
	end

	def discount_percent(original_price, discount_price)
		(discount_price / original_price) * 100
	end

	def price_with_discount(original_price, discount_price)
		if discount_price.present?
			original_price - discount_price 
		else
			original_price
		end
	end

	private
 		#ensure that there are no line items referencing this product
		def ensure_not_referenced_by_any_line_item
		 	if line_items.empty?
		 		return true
		 	else
		 		errors.add(:base, 'Line Items present')
		 		return false
			end
		end

end

app/models/product_attribute.rb
class ProductAttribute < ActiveRecord::Base
	belongs_to :product
end

app/models/slider.rb
class Slider < ActiveRecord::Base
	mount_uploader :image, SliderUploader
end

app/models/support_message.rb
class SupportMessage < ActiveRecord::Base
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
  has_many :orders
end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController

  include CurrentCart
  before_action :set_cart

  def home
    @sliders = Slider.all
    @discount_products = Product.where("discount IS NOT NULL").order("RANDOM()").limit(4)
    @top_products = Product.order("times_bought DESC").limit(4)
    @special_products = Product.where("special IS TRUE").order("RANDOM()").limit(4)
    #where.not(user_id: "")
    #User.find(:all, )
    #Model.order('rand()').limit(1).first.name
  end
  
end

app/helpers/application_helper.rb
module ApplicationHelper

	def resource_name
    :user
  end

  def resource
    @resource ||= User.new
  end

  def devise_mapping
    @devise_mapping ||= Devise.mappings[:user]
  end

  

end

app/helpers/carts_helper.rb
module CartsHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/charges_helper.rb
module ChargesHelper
end

app/helpers/departments_helper.rb
module DepartmentsHelper
end

app/helpers/images_helper.rb
module ImagesHelper
end

app/helpers/line_items_helper.rb
module LineItemsHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper

	
end

app/views/shared/static_page/_dep_and_cat_list.html.erb
 <!-- Department and category list for navbar 
data aviable in seed files-->
<% departments = Department.all.order("id")
	categories = Category.all .order("id")
  category_counter = 0 %>
<% departments.each_with_index do |department, index| %>
  <li>
    <%= link_to "#{department.name}", categories_path(selected: "#{index + 1}") %>
  </li>
<% end %>
  

app/views/shared/static_page/_footer.html.erb
<div class="container-fluid footer-info">
    <div class="row">
    	  <div class="col-md-4 center-block text-center where-to-find-us">
            <h3>Contact us</h3>
            <%= link_to " Send us a message", support_path, class: "glyphicon glyphicon-pencil", style: "font-family: 'Open Sans'; font-size: 20px;" %>
    		<h2 class="phone">+ 1-800-487-1254</h2>
    		<i class="glyphicon glyphicon-map-marker"></i>&nbsp; Rīga, Braslas iela 16, LV-1084  <br>
    		<i class="glyphicon glyphicon-envelope"></i>&nbsp;<a href="mailto:marisancans@gmail.com"> marisancans@gmail.com</a>
        </div>
        <div class="col-md-4">
        	<h1 class="text-center">Flybit</h1>
    			<div class="image-swap center-block"></div>
    		</div>
    		<div class="col-md-4 text-center center-block about-us">
          <h3>About us</h3>
          <p>We are proffesional e-commerce traders with years of experience. We are making sure that each and every order gets to it's destination. We have trusted parners who deliver high quality products with guarantee.</p>
        </div>
    </div>
</div>
<div class="text-center footer-copyright">
    <div class="container-fluid link">
      <h5>© 2016 Copyright: <a href="http://www.Flybit.com"> Flybit.com </a></h5>
    </div>
</div>

app/views/shared/static_page/_left_side_navbar.html.erb
<div class="col-md-1">
  <div class="left-side-navbar">
    <ul class="nav nav-pills nav-stacked pull-left" >
      <li><%= link_to t('.home'),    root_url %></li>
      <li><%= link_to t('.products'),   root_url %></li>
      <li><%= link_to t('.products'),   root_url %></li>
    </ul>
  </div>
</div>


<!--
<li><%= link_to "Home", root_path %></li>
<li><%= link_to "Contact", contact_path %></li>
-->

app/views/shared/static_page/_login_form.html.erb
<!--<li class="dropdown">
  <a href="#" class="dropdown-toggle" data-toggle="dropdown"><b>Login</b> <span class="caret"></span></a> -->

  <button class="btn btn-default dropdown-toggle" type="button" data-toggle="dropdown" style = "margin-top: 2%; background-color: #222; border-color: #222;"><b style="color: #9d9d9d;"> Login</b>
  <span class="glyphicon glyphicon-user" style = "color: white; font-size: 1.2em;"></span></button>

  <ul id="login-dp" class="dropdown-menu">
    
    <li>
      
      <div class="row">
        <div class="col-md-12">
          <%= form_for(resource, as: resource_name, url: session_path(resource_name)) do |f| %>
          <div class="email_login">
            <%= f.label :email %><br />
            <%= f.email_field :email, autofocus: true %>
          </div>

          <div class="pass_login">
            <%= f.label :password %><br />
            <%= f.password_field :password, autocomplete: "off" %>
          </div>

          <% if devise_mapping.rememberable? -%>
            <div class="pass_remember_login">
              <%= f.check_box :remember_me %>
              <%= f.label :remember_me %>
            </div>
          <% end -%>

          <div class="actions">
            <%= f.submit "Log in" %>
          </div>
        <% end %>
        <a id = "no-account" class="btn btn-sq-lg btn-primary " <%= link_to new_user_registration_path do %>
          Register</a>
          <% end %>
        </div>
      </div>
    </li>
  
  </ul>
</li>

app/views/shared/static_page/_navbar.html.erb
<nav class="navbar navbar-inverse navbar-fixed-top">
  <div class="container-fluid">
    <!-- navbar collapse button brand logo -->
    <div class="navbar-header">
      <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbar-collapse-1">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
        <!-- Navbar brand logo -->
        <%= link_to root_path do %>
          <%= image_tag "logo.png", "class": "navbar-brand" %>
        <% end %>
    </div>

    <div class="collapse navbar-collapse" id="navbar-collapse-1">
      <!-- department list -->
      <ul class = "nav navbar-nav">
        <% cache 'dep_and_cat_list' do %>
          <%= render 'shared/static_page/dep_and_cat_list' %>
        <% end %>
          <!-- search field -->
        <li>
          <form class="navbar-form pull-left" action="/search" accept-charset="UTF-8">
            <div class="input-group">
                <div class="input-group-btn">
                  <button type="submit" class="btn btn-default" style="background-color: #222; border-color: #222"><span class="glyphicon glyphicon-search" style="color: white;"></span></button>
               </div>
               <input type="text" class="form-control search-feld" name="search" placeholder="Search all products" style="border-color: #222; background-color : #222; color: white;">
            </div>
          </form>
        </li>
      </ul>
        <!-- Cart, login, register -->
        <ul class="nav navbar-nav navbar-right">
          <% if @cart  && controller.controller_name != 'carts' && controller.controller_name != 'charges' %> <!-- Cart  -->
            <li>
                <%= link_to navbar_cart_path, { method: :get, remote: true, class: "btn btn-default dropdown-toggle", "id": "cart-button", "data-toggle": "dropdown" }  do %>
                  <div>
                    <span class="glyphicon glyphicon-shopping-cart" style = "color: white; font-size: 1.2em;"></span>
                    <span class="badge" id="cart-badge-id"><%="#{@cart.line_items_count}" %></span>
                  </div>
                <% end %>
                <ul class="dropdown-menu" id="cart-dropdown">
                  <div id="cart">
                    <p class ="text-center loading">Loading...</p>
                  </div>
                </ul>
            </li>
          <% end %> <!--End of cart-->

          <!-- user session links -->
          <% if user_signed_in? %>
            <li>
              <%= link_to "Profile", edit_user_registration_path %>
            </li>
            <li>
              <%= link_to "Sign out", destroy_user_session_path, :method => :delete %> 
            </li>
          <% else %>
            <li>
              <%= link_to "Log in", new_user_session_path %>
            </li>
            <li>
              <%= link_to "Register", new_user_registration_path %>
            </li>
          <% end %>
        </ul>
    </div><!-- end of collapse -->
  </div>
</nav>

app/views/shared/static_page/_right_side_navbar.html.erb
<div class="right-side-navbar">
  <div class="col-sm-1">  
        <ul class="nav nav-pills nav-stacked">
          <li><%= link_to t('.home'),    root_url %></li>
          <li><%= link_to t('.products'),   root_url %></li>
          <li><%= link_to t('.products'),   root_url %></li>
        </ul>

  </div>
</div>

app/views/static_pages/home.html.erb
<%= stylesheet_link_tag "navbar", "home_page", "products", "footer" %>
<% @title="Flybit" %>

<div class="container">
  <% if notice %>
    <p class="alert alert-info" id = "notice"><%= notice %></p>
  <% end %>
  <div class="row content">
    <div class="col-md-12">
      <div id="carousel-example-generic" class="carousel slide" data-ride="carousel">
        <!-- Indicators -->
        <ol class="carousel-indicators">
          <li data-target="#carousel-example-generic" data-slide-to="0" class="active"></li>
          <% @sliders.drop(1).each_with_index do |slider, index| %>
            <li data-target="#carousel-example-generic" data-slide-to="<%= index + 1 %>" ></li>
          <% end %>
        </ol>
     
        <!-- Wrapper for slides -->
        <div class="carousel-inner">
          <div class="item active">
            <a href="<%= @sliders.first.url if !@sliders.first.nil? %>">
              <%= cl_image_tag @sliders.first.image, :width => 1200, :height => 315, :crop=>"pad" if @sliders.exists? %>
              <div class="carousel-caption">
                  <h3><%= @sliders.first.title if @sliders.exists? %></h3>
              </div>
            </a>
          </div>
          <% @sliders.drop(1).each do |slider| %>
            <div class="item">
              <a href="<%= slider.url %>">
                <%= cl_image_tag slider.image, :width => 1200, :height => 315, :crop=>"pad" %>
                <div class="carousel-caption">
                    <h3><%= slider.title %></h3>
                </div>
              </a>
            </div>
          <% end %>
        </div>
     
        <!-- Controls -->
        <a class="left carousel-control" href="#carousel-example-generic" role="button" data-slide="prev">
          <span class="glyphicon glyphicon-chevron-left"></span>
        </a>
        <a class="right carousel-control" href="#carousel-example-generic" role="button" data-slide="next">
          <span class="glyphicon glyphicon-chevron-right"></span>
        </a>
      </div>
    </div>
  </div>

  <div class="row row-line text-center">
    <div class="col-md-12">
      <span class="row-line-text">Discounts</span>
      <hr class="hr-tag">
    </div>
  </div>

  <div class="row">
    <div class="col-md-12">
      <% @discount_products.each do |product| %>
        <%= render product %>
      <% end %>
    </div>
  </div>

  <div class="row row-line text-center">
    <span class="row-line-text">Special offers</span>
    <hr class="hr-tag">
  </div>

  <div class="row">
    <div class="col-md-12">
      <% @special_products.each do |product| %>
        <%= render product %>
      <% end %>
    </div>
  </div>

  <div class="row row-line text-center">
    <span class="row-line-text">Top products</span>
    <hr class="hr-tag">
  </div>

  <div class="row">
    <div class="col-md-12">
      <% @top_products.each do |product| %>
        <%= render product %>
      <% end %>
    </div>
  </div>
</div>            